/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __CONFIGTB_H__
#define __CONFIGTB_H__

#include <qstring.h>
#include <qstrlist.h>
#include <qlist.h>
#include <qfile.h>
#include <qpixmap.h>
#include <stdlib.h>

struct actioninfo
{
	char leftbutton[2048]; // actions a entreprendre (elles doivent etre separees par des \n)
	char rightbutton[2048]; // actions a entreprendre (elles doivent etre separees par des \n)
	unsigned char leftPixmap[2048]; // image a afficher dans la toolbar (boutton de gauche)
	unsigned char rightPixmap[2048]; // idem pour le boutton droit
	int leftIndex; // index qui correspond au pixmap du boutton gauche
	int rightIndex;
};


class CConfigToolBar
{
	public:
		CConfigToolBar(QString file);
		// ouvre le fichier selectionne

		actioninfo *get(const unsigned int index);
		// renvoie le type de fichier correspondant a l'indice

		void set(const unsigned int i, actioninfo *k);

		int addEntry(QString leftValue, int leftIndex, QString rightValue, int rightIndex);
		// rajoute un nouveau boutton dans la toolbar
		// et renvoie l'indice de ce type

		bool removeEntry(int ind);
		// enleve l'entree qui correspond a l'indice ind

		void clear() { free(total); total = 0; nb = 0; }

		void save();
		// sauvegarde la configuration sur le disque

		~CConfigToolBar() { save(); }
		// destructeur qui va remettre sur disque tous les changements effectues

	private:

		void readFile();
		// va lire le fichier de configuration
		// par exemple au debut (lors de l'instanciation oubien apres avoir sauve)

		QString localName;
    
		actioninfo *total;
		// on stocke dans cette liste toutes les lignes du fichier
		// pour pouvoir le restaurer intact a la terminaison du programme

		bool changed;
		// pour savoir si on  doit reecrire les changements dans le fichier en quittant

		char buffer[2048];
		// tampon pour la lecture dans le fichier

		unsigned int nb;
		// nombre de boutton trouve

		actioninfo *actionInfo, *parcours;

};

#endif
