/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __CACTION_AASSOCIATION__H___
#define __CACTION_AASSOCIATION__H___

#include <qstrlist.h>
#include "actionAssociationDialog.h"
#include "../cconfig.h"
#include "../configOpt.h"
#include "../toolbar.h"


class CActionAssociationDialog : public actionAssociationDialog
{
	Q_OBJECT
	public:
		CActionAssociationDialog(fileinfo *f, CConfigOpt *co, int n, QWidget *parent = 0, const char *name = 0);
		CActionAssociationDialog(ZToolbar *to, QString title, int index, QWidget *parent = 0, const char *name = 0);


	protected:
		fileinfo *lf;
		CConfigOpt *lco;
		int ln;

		ZToolbar *toolbar;
		int currentCell;

		QStrList doubleclick;
		QStrList doubleclickshift;
		QStrList doubleclickctrl;
		QStrList doubleclickalt;

		enum mode_t { FILETYPE, TOOLBAR };
		mode_t mode;

	protected slots:
		void OnAdd();
		void OnWhat();
		void OnDelete();
		void OnInsert();
		void actionHighlighted(int);
		void returnPressed();
		void OnArgument();
		void OnUse();
		void OnCancel();

};

#endif
