/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __CCLASSDIALOG_H__
#define __CCLASSDIALOG_H__

#include "classDialog.h"
#include "../cconfig.h"
#include "../configOpt.h"

class CClassDialog : public classDialog
{
	Q_OBJECT
	public:
		CClassDialog(fileinfo *f, CConfigOpt *co, QWidget *parent = 0, const char *name = 0);

	protected:
		fileinfo *lf;
		CConfigOpt *lco;
		QStrList pattern;
		int current;
		void contenu() { debug("Contenu de la liste"); for (unsigned int i = 0 ; i < pattern.count() ; debug("%s", pattern.at(i++))); }

	protected slots:
		void OnAdd();
		void OnUse();
		void OnView();
		void OnCancel();
		void OnRemove();
		void OnWhat();
		void textChanged(const char *);
		void patternsHighlighted(int);
		void returnPressed();
		void OnRemoveIcon();
		void OnSelect();
};

#endif
