/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include <string.h> // strlen()
#include "CFileEventsDialog.h"
#include "CActionAssociationDialog.h"
#include "CClassDialog.h"

CFileEventsDialog::CFileEventsDialog(CConfig *c, CConfigOpt *co, int n, QWidget *parent, const char *name)
	: fileEventsDialog(parent, name), lc(c), ln(n), lco(co)
{
	edit -> setEnabled(FALSE);
	deletebt -> setEnabled(FALSE);

	fileinfo *sel = lc -> getByIndex(n);
	setCaption(sel -> title);
	
	debug("%s", sel -> doubleclick);
	addEntry("Double click");
	if (strlen(sel -> doubleclick))
		actions -> setSelected(0, TRUE);

	addEntry("Double click + Shift");
	if (strlen(sel -> doubleclickshift))
		actions -> setSelected(1, TRUE);
	
	addEntry("Double click + Ctrl");
	if (strlen(sel -> doubleclickctrl))
		actions -> setSelected(2, TRUE);

	addEntry("Double click + Alt");
	if (strlen(sel -> doubleclickalt))
		actions -> setSelected(3, TRUE);


	QObject::connect(actions, SIGNAL(clicked(int)), SLOT(OnListClicked(int)));
	QObject::connect(actions, SIGNAL(dblClicked(int)), SLOT(OnListPressed(int)));
}

void CFileEventsDialog::addEntry(QString g)
{
	actions -> addEntry(g);
}


void CFileEventsDialog::OnListClicked(int n)
{
	current = n;
	edit -> setEnabled(TRUE);
	deletebt -> setEnabled(TRUE);
}


void CFileEventsDialog::OnListPressed(int n)
{
	CActionAssociationDialog ca(lc -> getByIndex(ln), lco, n, this);
	int res = ca.exec();

	if (res == 0)
		actions -> setSelected(current, FALSE);
	else if (res > 0)
		actions -> setSelected(current, TRUE);

}


void CFileEventsDialog::OnUse()
{
	done(1);
}


void CFileEventsDialog::OnEdit()
{
	CActionAssociationDialog ca(lc -> getByIndex(ln), lco, current, this);
	int res = ca.exec();

	if (res == 0)
		actions -> setSelected(current, FALSE);
	else if (res > 0)
		actions -> setSelected(current, TRUE);
}


void CFileEventsDialog::OnCancel()
{
	done(1);
}


void CFileEventsDialog::OnClass()
{
	CClassDialog cdialog(lc -> getByIndex(ln), lco, this);
 
	cdialog.exec();

}
