#include <stdlib.h> // atoi()
#include <stdio.h> // printf()
//#include <qfile.h>
#include <qfiledialog.h>
#include "../plugins/zcomponent.h"
#include "CNewFileTypeDialog.h"
#include "CClassDialog.h"

CNewFileTypeDialog::CNewFileTypeDialog(CConfig *lc, CConfigOpt *opt, char *fileName, QWidget *parent, const char *name)
  : newFileType(parent, name), localF(fileName), lco(lc), opto(opt)
{
  bytes -> setValue(10);
  list -> insertItem(fileName);
  list -> setCurrentItem(0);
  firstTime = true;
}

void CNewFileTypeDialog::setModule(inComponent *mod)
{
	module = mod;
}

void CNewFileTypeDialog::addClicked()
{
  QString file;
  QStrList liste;

  if (firstTime == true)
  {
    QString dir = QFileInfo(localF).dirPath();
    liste = QFileDialog::getOpenFileNames(0, dir);
    firstTime = false;
  }
  else
  {
    QString dir = QFileInfo(lastFile).dirPath();
    liste = QFileDialog::getOpenFileNames(0, dir);
  }

  for(int i = 0 ; i < liste.count() ; i++)
  //if (!file.isEmpty())
  {  
    list -> insertItem(liste.at(i));
    recognitionButton -> setEnabled(true);
    clearButton -> setEnabled(true);
  }

  if (liste.count() > 0)
    lastFile = liste.getLast();
}

void CNewFileTypeDialog::clearClicked()
{
  list -> clear();
  removeButton -> setEnabled(false);
  recognitionButton -> setEnabled(false);
  clearButton -> setEnabled(false);
}

void CNewFileTypeDialog::removeClicked()
{
  list -> removeItem(list -> currentItem());
  if (list -> count() == 0)
  {  
    removeButton -> setEnabled(false);
    recognitionButton -> setEnabled(false);
    clearButton -> setEnabled(false);
  }

}

void CNewFileTypeDialog::cancelClicked()
{
  done(1);
}

void CNewFileTypeDialog::itemSelected(int n)
{
  removeButton -> setEnabled(true);
  //recognitionButton -> setEnabled(false);
}

void CNewFileTypeDialog::recognitionClicked()
{
  char lec;

  int value = bytes -> value();
  if (value <= 0)
  {
    debug("Wrong value of bytes to compare.");
    return;
  }

  QByteArray bytesRead(value);
  //bytesRead[ value ] = 0; // end of line

  for ( int i = 0 ; i < list -> count() ; i++)
  {
    module -> open(list -> text(i), IO_ReadOnly);
	//QFile f(list -> text(i));
    //f.open(IO_ReadOnly);

    for(int j = 0 ; j < value ; j++)
    {
		module -> readBlock(&lec, 1);
		//f.readBlock(&lec, 1);
		bytesRead[j] = lec;
    }

    reads.append(new QByteArray(bytesRead.copy()));
    //debug("%s", bytesRead);
    //f.close();
	module -> close();
  }

  QByteArray *temp = reads.at(0), *temp2;
  equals = new int[value];

  for(i = 0 ; i < value ; equals[i++] = 0);

  for (i = 1 ; i < list -> count() ; i++)
  {
    temp2 = reads.at(i);
    //equal = true;
    for (int j = 0 ; j < temp -> size() ; j++)
    {
		if (temp -> at(j) == temp2 -> at(j))
		equals[j]++;
    }
  }
   
  //debug("Resul : ");
  //for(i = 0 ; i < value ; i++)
  //{
  // debug("%d : %d (%s)", i, equals[i], ((equals[i] == list -> count() - 1) ? "ok" : ""));
  //}

  //debug("So, recognition pattern is :");
  //for(i = 0 ; i < temp -> size() ; i++)
  //{
  //  if (equals[i] == list -> count() - 1)
  //    debug("%c[%d],", temp -> at(i), (temp -> at(i) >= 0 ? temp -> at(i) : 256 + temp -> at(i)));
  //}

  int res = lco -> addEntry();
  fileinfo *lf = lco -> getByIndex(res);

  QString fc; // file recognition
  QString stemp;
  bool toMove = false;
  bool match = false;
  for(i = 0 ; i < temp -> size() ; i++)
  {
    if (equals[i] == list -> count() - 1) // this offset is ok
    {
      if (toMove == true)
      {
	fc.resize(fc.length());
	fc += "\n";
	stemp.setNum(i);
	fc += "moveto=";
	fc += stemp.copy().data();
	fc += "\n";
	//fc.append("\n");
	toMove = false;
	match = false;
      }
      stemp.setNum((temp -> at(i) >= 0 ? temp -> at(i) : 256 + temp -> at(i)));
      
      if (match == false)
      {
	fc.append("matchbyte=");
	match = true;
      }

      fc += stemp.copy().data();
      //if (i != list -> count() - 1) 
	fc.append(",");
    }
    else
      toMove = true;
    // debug("%c[%d],", temp[i], (temp[i] >= 0 ? temp[i] : 255 + temp[i]));
  }

  fc.resize(fc.length());
  //lf -> recognition = new char [ fc.length() + 1 ];
  strcpy(lf -> recognition, fc.data());

  CClassDialog dlg(lf, opto, this);
  int r = dlg.exec();
  
  if (r == 1) // use clicked()
  {
    lco -> save();
    done(1);
  }
  else if (r == -1)
    lco -> removeEntry(res);

  //debug("res : ");
  //debug("%s", fc.data());
}  
