/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __MYLISTBOX_H__
#define __MYLISTBOX_H__


#include <qpixmap.h>
#include <qbitmap.h>	
#include <qlistbox.h>
#include <qpainter.h>
#include "check.h" // image de la check-mark

class myListBox : public QListBox
{
	Q_OBJECT
	public:
		myListBox(QWidget *parent = 0, const char *name = 0);

		void addEntry(QString);
		// permet de rajouter une entree

		bool isSelected(int indice) { return (Entry + indice) -> selected; }
		void setSelected(int indice, bool b);

	private:
		
		void deSelect(int indice = -1);
		// permet de deselectionner un (indice >= 0) ou plusieurs elements de la liste(indice = -1)

		QPixmap check;
		QBitmap check_mask;

		struct entry
		{
			bool selected; // pour savoir si tel element est selectionne ou pas
			char text[40]; // texte qui correspond
		};
	
		entry *Entry;

		int current;

		int nb;
		// nombre d'elements dans la liste

		void paintCell(QPainter *p, int row, int col);
		// pour prendre en charge l'affichage des cellules

		void mousePressEvent(QMouseEvent *);
		void mouseDoubleClickEvent(QMouseEvent *);

	signals:
		void clicked(int);
		void dblClicked(int);
};

#endif
