/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __ZFILEINFO_H__
#define __ZFILEINFO_H__

#include <qfileinfo.h>

class ZFileInfo : public QFileInfo
{
    public:
    	ZFileInfo(const char *file) { selected = FALSE; }
		ZFileInfo() {}
		ZFileInfo(QFileInfo *p) : QFileInfo(*p) { selected = FALSE; }
	// constructeur
	
	bool isSelected() { return selected; }
	// renvoie vraie si l'objet est selectionne

	void setSelected(const bool sel) { selected = sel; }
	// active ou desactive l'item

    private:
    	bool selected;

}; // class ZFileInfo	


class ZFileInfoDevice
{
	public:
		ZFileInfoDevice() {}

		QString &rootPath() { return str_rootPath; }
		void setRootPath( QString path ) { str_rootPath = path; }

		QString &fileSystem() { return str_fileSystem; }
		void setFileSystem( QString file ) { str_fileSystem = file; }

		bool mounted() { return b_mounted; }
		void setMounted( bool b ) { b_mounted = b; }

		bool isSelected() { return b_selected; }
		void setSelected(bool s) { b_selected = s; }

		unsigned long available() { return long_available; }
		void setAvailable( unsigned long a ) { long_available = a; }

		unsigned long used() { return long_used; }
		void setUsed( unsigned long u ) { long_used = u; }

	private:
		QString str_rootPath;
		QString str_fileSystem;
		bool b_mounted, b_selected;
		unsigned long long_available;
		unsigned long long_used;

}; // class ZFileInfoDevice

#endif
