#include "colordialog.h"

ZColorDialog::ZColorDialog(QWidget *parent, const char *name, bool modal)
	: QDialog(parent, name, modal)
{
	listbox = new QListBox(this);

	green = new QSlider(0, 255, 10, 100, QSlider::Vertical, this);
	red = new QSlider(0, 255, 10, 100, QSlider::Vertical, this);
	blue = new QSlider(0, 255, 10, 100, QSlider::Vertical, this);
	
	ok = new QPushButton("Ok", this);

	label = new QLabel(this);

	connect (red, SIGNAL(valueChanged(int)), this, SLOT(sliderMoved()));
	connect (red, SIGNAL(sliderMoved(int)), this, SLOT(sliderMoved()));

	connect (green, SIGNAL(valueChanged(int)), this, SLOT(sliderMoved()));
	connect (green, SIGNAL(sliderMoved(int)), this, SLOT(sliderMoved()));

	connect (blue, SIGNAL(valueChanged(int)), this, SLOT(sliderMoved()));
	connect (blue, SIGNAL(sliderMoved(int)), this, SLOT(sliderMoved()));

	connect (blue, SIGNAL(sliderReleased()), SIGNAL(sliderReleased()));
	connect (green, SIGNAL(sliderReleased()), SIGNAL(sliderReleased()));
	connect (red, SIGNAL(sliderReleased()), SIGNAL(sliderReleased()));

	connect (listbox, SIGNAL(highlighted(int)), this, SLOT(listClicked(int)));

	setMinimumSize(300, 200);

	currentColor = 0;
	//updateSliders();

	//sliderMoved();
	// mise a jour de la couleur du label
}	


void ZColorDialog::addEntry(char *entry, QColor col)
{
	listbox -> insertItem(entry);
	color[currentColor].red = color[currentColor].green = color[currentColor++].blue = 0;
}


void ZColorDialog::updateSliders()
{
	debug("%d %d %d", color[currentColor].red, color[currentColor].green, color[currentColor].blue);
	red -> setValue(color[currentColor].red);
	green -> setValue(color[currentColor].green);
	blue -> setValue(color[currentColor].blue);
	//sliderMoved();
	QColor temp(red -> value(), green -> value(), blue -> value());
	label -> setPalette( temp );
	
};


void ZColorDialog::resizeEvent(QResizeEvent *e)
{
	listbox -> setGeometry(4, 4, width() - 90, height() - 35);

	label -> setGeometry(width() - 82, 4, width() - 80, 20);

	red -> setGeometry(width() - 68, 28, 20, height() - 55);
	green -> setGeometry(width() - 46, 28, 20, height() - 55);
	blue -> setGeometry(width() - 24, 28, 20, height() - 55);

	ok -> setGeometry(((width() - 20) / 2) - 10, height() - 20, 20, 15);

}


void ZColorDialog::sliderMoved()
{
	QColor temp(red -> value(), green -> value(), blue -> value());
	label -> setPalette( temp );
	color[currentColor].red = red -> value();
	color[currentColor].green = green -> value();
	color[currentColor].blue = blue -> value();

	emit colorChanged(currentColor, temp);
}


void ZColorDialog::listClicked(int id)
{
	currentColor = id;
	//debug("id : %d", id);
	updateSliders();
}
