#ifndef __FTPPLUGIN_H__
#define __FTPPLUGIN_H__

#include <qdir.h>
#include <qstrlist.h>
#include <qstring.h>
#include "../list.h"
#include "zcomponent.h"
#include "ftplib.h"

class ftpPlugin;

class Module : public inComponent
{
	Q_OBJECT
    public:
		Module();

		ZList &scan(QString path);
		bool exists(QString path);
		QString cdUp();
		
		QStrList getMenu();

    protected:
		ftpPlugin *component;

	public slots:
		void menuClicked(int);

};

class ftpPlugin
{
	
  public:

    ftpPlugin();

    ZList &scan(QString path);
    // scanne le repertoire path et renvoie une liste chainee sur les fichiers et repertoires

	QString cdUp();
	// sert a remonter d'un niveau

	bool exists(QString path);

	QStrList getMenu();
	void menuClicked(int);

  protected:
    
    QDir dir;
    ZList list;

	bool dotFiles;
	// pour savoir si on doit afficher les fichiers caches

	bool firstDirs;
	// affichage des repertoires en premier

	bool caseSensitive;
	// sensible aux minuscules/majuscules

	bool optionsChanged;
	// pour savoir si une option a ete changee
	// si non : scan
	// si oui : pas de scan mais un autre tri de la liste

	netbuf *conn;
	QString host;
	QString user;
	QString pass;

	bool connected;
};

#endif
