/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef TOOLBAR_H_
#define TOOLBAR_H_

#include <qwidget.h>
#include <qlist.h>
#include <qstrlist.h>
#include <qtableview.h>
#include <qpixmap.h>
#include <qtimer.h>

#include "configToolBar.h"

// toolbutton images
#include "images/3D.h"
#include "images/AddIcon.h"
#include "images/All.h"
#include "images/Amiga.h"
#include "images/Arexx.h"
#include "images/ArrangeLs.h"
#include "images/Assign.h"
#include "images/Blanker.h"
#include "images/CD.h"
#include "images/CDisk.h"
#include "images/Cache.h"
#include "images/Calculator.h"
#include "images/Clip.h"
#include "images/ClipBoard.h"
#include "images/Comment.h"
#include "images/Compare.h"
#include "images/Connect.h"
#include "images/Copy.h"
#include "images/CopyAs.h"
#include "images/CopyDir.h"
#include "images/CopyWin.h"
#include "images/DateStamp.h"
#include "images/Delete.h"
#include "images/Device.h"
#include "images/DirDrawer.h"
#include "images/DiskCopy.h"
#include "images/EdHotList.h"
#include "images/Edit.h"
#include "images/EditSS.h"
#include "images/FTP.h"
#include "images/FTPReceive.h"
#include "images/FTPSend.h"
#include "images/FastView.h"
#include "images/Font.h"
#include "images/Format.h"
#include "images/Game.h"
#include "images/GetSizes.h"
#include "images/Globe.h"
#include "images/GoldEd.h"
#include "images/GotoFirst.h"
#include "images/GotoNext.h"
#include "images/GrapeVine.h"
#include "images/HD.h"
#include "images/HangUp.h"
#include "images/HardCopy.h"
#include "images/HeadTail.h"
#include "images/Help.h"
#include "images/HotList.h"
#include "images/Hound.h"
#include "images/IconInfo.h"
#include "images/InkFeather.h"
#include "images/Join.h"
#include "images/Library.h"
#include "images/Magnify.h"
#include "images/Mail.h"
#include "images/Make.h"
#include "images/MakeDir.h"
#include "images/Modem.h"
#include "images/Move.h"
#include "images/MoveAs.h"
#include "images/Movie.h"
#include "images/MultiView.h"
#include "images/Mystery.h"
#include "images/NewDrawer.h"
#include "images/News.h"
#include "images/None.h"
#include "images/PC.h"
#include "images/Pack.h"
#include "images/PaintBrush.h"
#include "images/Parent.h"
#include "images/Parent2Dest.h"
#include "images/PathNew.h"
#include "images/PathTempRam.h"
#include "images/Pencil.h"
#include "images/Play.h"
#include "images/Print.h"
#include "images/Protect.h"
#include "images/Ram.h"
#include "images/RamFlush.h"
#include "images/RandSound.h"
#include "images/ReSelect.h"
#include "images/Read.h"
#include "images/Relabel.h"
#include "images/RemoveSizes.h"
#include "images/Rename.h"
#include "images/Root.h"
#include "images/Sample.h"
#include "images/Scales.h"
#include "images/Search.h"
#include "images/SearchDrawer.h"
#include "images/Select.h"
#include "images/Send.h"
#include "images/Shell.h"
#include "images/Show.h"
#include "images/Speakers.h"
#include "images/Split.h"
#include "images/SwapWin.h"
#include "images/SysPrefs.h"
#include "images/System.h"
#include "images/Telephone.h"
#include "images/Test.h"
#include "images/TrashCan.h"
#include "images/UnPack.h"
#include "images/Wand.h"
#include "images/World.h"
#include "images/YingYang.h"
#include "images/Zzz.h"

struct pixmapinfo
{
    char name[20];
    const unsigned char *pixmap;
    int size;
};

const pixmapinfo pixmapInfo[] = {
    { "3D", pixmap_3D, 989 },
    { "AddIcon", AddIcon, 968 },
    { "All", All, 981 },
    { "Amiga", Amiga, 941 },
    { "Arexx", Arexx, 993 },
    { "ArrangeLs", ArrangeLs, 968 },
    { "Assign", Assign, 963 },
    { "Blanker", Blanker, 962 },
    { "CD", CD, 969 },
    { "CDisk", CDisk, 964 },
    { "Cache", Cache, 985 },
    { "Calculator", Calculator, 961 },
    { "Clip", Clip, 954 },
    { "ClipBoard", ClipBoard, 967 },
    { "Comment", Comment, 955 },
    { "Compare", Compare, 972 },
    { "Connect", Connect, 963 },
    { "Copy", Copy, 953 },
    { "CopyAs", CopyAs, 976 },
    { "CopyDir", CopyDir, 967 },
    { "CopyWin", CopyWin, 976 },
    { "DateStamp", DateStamp, 979 },
    { "Delete", Delete, 981 },
    { "Device", Device, 962 },
    { "DirDrawer", DirDrawer, 963 },
    { "DiskCopy", DiskCopy, 964 },
    { "EdHotList", EdHotList, 980 },
    { "Edit", Edit, 976 },
    { "EditSS", EditSS, 981 },
    { "FTP", FTP, 957 },
    { "FTPReceive", FTPReceive, 981 },
    { "FTPSend", FTPSend, 984 },
    { "FastView", FastView, 962 },
    { "Font", Font, 964 },
    { "Format", Format, 960 },
    { "Game", Game, 962 },
    { "GetSizes", GetSizes, 972 },
    { "Globe", Globe, 984 },
    { "GoldEd", GoldEd, 962 },
    { "GotoFirst", GotoFirst, 952 },
    { "GotoNext", GotoNext, 954 },
    { "GrapeVine", GrapeVine, 972 },
    { "HD", HD, 977 },
    { "HangUp", HangUp, 971 },
    { "HardCopy", HardCopy, 945 },
    { "HeadTail", HeadTail, 962 },
    { "Help", Help, 959 },
    { "HotList", HotList, 967 },
    { "Hound", Hound, 967 },
    { "IconInfo", IconInfo, 942 },
    { "InkFeather", InkFeather, 979 },
    { "Join", Join, 964 },
    { "Library", Library, 982 },
    { "Magnify", Magnify, 950 },
    { "Mail", Mail, 948 },
    { "Make", Make, 960 },
    { "MakeDir", MakeDir, 962 },
    { "Modem", Modem, 955 },
    { "Move", Move, 961 },
    { "MoveAs", MoveAs, 978 },
    { "Movie", Movie, 963 },
    { "MultiView", MultiView, 986 },
    { "Mystery", Mystery, 975 },
    { "NewDrawer", NewDrawer, 945 },
    { "News", News, 939 },
    { "None", None, 986 },
    { "PC", PC, 959, },
    { "Pack", Pack, 994 },
    { "PaintBrush", PaintBrush, 975 },
    { "Parent", Parent, 952 },
    { "Parent2Dest", Parent2Dest, 970 },
    { "PathNew", PathNew, 957 },
    { "PathTempRam", PathTempRam, 960 },
    { "Pencil", Pencil, 966 },
    { "Play", Play, 963 },
    { "Print", Print, 961 },
    { "Protect", Protect, 969 },
    { "Ram", Ram, 952 },
    { "RamFlush", RamFlush, 962 },
    { "RandSound", RandSound, 976 },
    { "ReSelect", ReSelect, 963 },
    { "Read", Read, 978 },
    { "Relabel", Relabel, 984 },
    { "RemoveSizes", RemoveSizes, 984 },
    { "Rename", Rename, 978 },
    { "Root", Root, 967 },
    { "Sample", Sample, 967 },
    { "Scales", Scales, 977 },
    { "Search", Search, 964 },
    { "SearchDrawer", SearchDrawer, 970 },
    { "Select", Select, 972 },
    { "Send", Send, 982 },
    { "Shell", Shell, 926 },
    { "Show", Show, 993 },
    { "Speakers", Speakers, 964 },
    { "Split", Split, 969 },
    { "SwapWin", SwapWin, 959 },
    { "Sysprefs", SysPrefs, 964 },
    { "System", System, 959 },
    { "Telephone", Telephone, 971 },
    { "Test", Test, 964 },
    { "TrashCan", TrashCan, 963 },
    { "UnPack", UnPack, 990 },
    { "Wand", Wand, 963 },
    { "World", World, 972 },
    { "YingYang", YingYang, 963 },
    { "Zzz", Zzz, 975 }, 
    { 0, 0, 0 }  
};

class ZToolbar : public QTableView
{
    Q_OBJECT
    public:
	ZToolbar(QWidget *parent = 0, const char *name = 0);
	void setConfig(CConfigToolBar *conf) { config = conf; }
	void readConfig();

	void clear();

	void setAction(int index, QString action);
	char *getAction(int index);
	void addEntry(int leftIndex, QString leftAction, int rightIndex, QString rightAction);
	void removeEntry(unsigned int index);
	int getNumCols() { return NumCols; }
	int getNumEntry(int index);

	void blink(int);
    // make blinking the corresponding toolbutton
    // -1 to stop

    protected:
	void paintCell(QPainter *, int, int);
	void resizeEvent(QResizeEvent *);

	void mousePressEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);

	int numRows() { return 1; }
	int numCols() { return NumCols; }
	int cellWidth(int i) { return 24; }
	int cellHeight(int i) { return 16; }
	int totalWidth() { return 24 * NumCols; }
	int totalHeight() { return 16; }

    private:
	QList<int> leftList;
	QList<int> rightList;

	QStrList leftActions, rightActions;

	int NumCols;

	int curCol;

	CConfigToolBar *config;

	QTimer timer;
	int currentBlink;
	bool toBlink;

    public slots:
	void timeOut();

    signals:
	void clicked(int index);
	// emited when the user click on a toolbutton
};

#endif
