/* This file is part of the zfm
    Copyright (C) 1998-99 GOUIRAN Christophe (Christophe.Gouiran@lpl.univ-aix.fr)
                          BELLET Vincent (vbellet@cybercable.fr)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

/*  utils.h
    projet : zdesktop
    auteur : BELLET Vincent, GOUIRAN Christophe
    description : primitives utilisees pour le chargement de composants */

#ifndef _UTILS_
#define _UTILS_


#include <qstring.h>
#include <iostream.h>
#include "./plugins/zcomponent.h"
#include "./plugins/zglcomponent.h"

class ZModule
{
    public:

		static void *loadModule(QString name);
		static outComponent *getOutModule(void *handle);
		static outGLComponent *getOutGLModule(void *handle);
		static inComponent *getInModule(void *handle);
		static void unloadModule(void *handle);
#ifndef WIN32
		static bool hasRootRights();
#endif
};

#endif
